Attribute VB_Name = "mdMaps"
Option Explicit
'My mapping functions's variables
Dim strResponse As String, strMsg As String, intFileNo As Integer
Function fnStripNull(ByVal strIn As String) As String
'Removes "null" characters from strings - chr$(0) isn't supported
'by windows
Dim intNullLoc As Integer

On Error GoTo Error_Stripping_CR: 'i.e. goto end

  intNullLoc = InStr(1, strIn, Chr$(0))

  If intNullLoc = 0 Then
    fnStripNull = strIn
    Exit Function
  Else
    fnStripNull = Left(strIn, (intNullLoc - 1))
    Exit Function
  End If
  
Error_Stripping_CR:
fnStripNull = strIn
Exit Function

End Function

Function fnErrorHan()
MsgBox "Error to report: " & Err.Description & ". No: " & Err.Number
End Function

Function fnBinDOC(ByVal strFileName As String, ByVal strcMapPath As String, ByVal strTitle As String)
'Function: To create a documentation file for a boolean raster map
'          note Data type integer bounds are +-32767
'Receives: strFileName, strcMapPath
'Expects: strcMapPath to have been declared as IDRISI ENVIRONMENT directory
On Error GoTo Err_MD
Dim intDoc As Integer
intDoc = FreeFile  'Number of file to open
strFileName = strcMapPath & "\" & strFileName & ".DOC"  'Add path and extension

'Delete previous version of file
    On Error Resume Next
    Kill strFileName
    On Error GoTo Err_MD
'Open file as new sequential file (for output)
    Open strFileName For Output As intDoc

Print #intDoc, "file title  : " & strTitle
Print #intDoc, "data type   : byte"          ' BECAUSE THESE ARE 0/1 FILES.
Print #intDoc, "file type   : ascii"
Print #intDoc, "columns     : 80"            'These values for extended neotropics
Print #intDoc, "rows        : 60"
Print #intDoc, "ref. system : latlong"
Print #intDoc, "ref. units  : deg"
Print #intDoc, "unit dist.  :  1"
Print #intDoc, "min. X      :  -110"        'Co-ordinates
Print #intDoc, "max. X      :  -30"
Print #intDoc, "min. Y      :  -30"
Print #intDoc, "max. Y      :  30"
Print #intDoc, "pos'n error : unknown"
Print #intDoc, "resolution  :  1"
Print #intDoc, "min. value  :  0"             'Assuming values positive
Print #intDoc, "max. value  :  1"
Print #intDoc, "value units : Presence/absence"
Print #intDoc, "value Error : unknown"
Print #intDoc, "flag value  : none"
Print #intDoc, "flag def'n  : none"
Print #intDoc, "legend cats : 2"
Print #intDoc, "category 0  : Not suitable/recorded"
Print #intDoc, "category 1  : Suitable/recorded"
                                    ' - those with straightforward codes
Close intDoc
Exit Function

Err_MD:

Call fnErrorHan
Exit Function
End Function


Function fnDblDOC(ByVal strFileName As String, ByVal strcMapPath As String, _
ByVal strTitle As String, ByVal dblMax As Double, ByVal dblMin As Double)
'Function: To create a documentation file for a real raster map
'          note Data type real bounds are  1.0E-38 to 1.0E+38
'Receives: strFileName, strcMapPath, dblMin and dblMax as max & min val
'Expects: strcMapPath to have been declared as IDRISI ENVIRONMENT directory

On Error GoTo Err_MD
Dim intDoc As Integer
intDoc = FreeFile  'Number of file to open
strFileName = strcMapPath & "\" & strFileName & ".DOC"  'Add path and extension

'Delete previous version of file
    On Error Resume Next
    Kill strFileName
    On Error GoTo Err_MD
'Open file as new sequential file (for output)
    Open strFileName For Output As intDoc

Print #intDoc, "file title  : " & strTitle
Print #intDoc, "data type   : real"          ' BECAUSE THESE ARE 0/1 FILES.
Print #intDoc, "file type   : ascii"
Print #intDoc, "columns     : 80"            'These values for extended neotropics
Print #intDoc, "rows        : 60"
Print #intDoc, "ref. system : latlong"
Print #intDoc, "ref. units  : deg"
Print #intDoc, "unit dist.  :  1"
Print #intDoc, "min. X      :  -110"        'Co-ordinates
Print #intDoc, "max. X      :  -30"
Print #intDoc, "min. Y      :  -30"
Print #intDoc, "max. Y      :  30"
Print #intDoc, "pos'n error : unknown"
Print #intDoc, "resolution  :  1"
Print #intDoc, "min. value  :  " & dblMin             'Assuming values positive
Print #intDoc, "max. value  :  " & dblMax
Print #intDoc, "value units : "
Print #intDoc, "value Error : unknown"
Print #intDoc, "flag value  : none"
Print #intDoc, "flag def'n  : none"
Print #intDoc, "legend cats : 0"

Close intDoc
Exit Function

Err_MD:

Call fnErrorHan
Exit Function
End Function
Public Function fnIntDVL(ByVal strFileName As String, ByVal RecNo As Integer, ByVal spcode As String, _
ByVal strcMapPath As String, ByVal strType As String, Optional ByVal dblMin As Double, _
Optional ByVal dblMax As Double)
'Function: To create a .val documentation file (.dvl)
'          Data type integer bounds are +-32767 in IDRISI
'Receives: strFileName without extension, RecNo = number of records, Spcode = species code
'           strType as Type of values file
'Expects: strcMapPath to have been declared as IDRISI ENVIRONMENT directory
On Error GoTo Err_MV
Dim intD As Integer, strVal As String, strData As String
intD = FreeFile  'Number of file to open
strcMapPath = fnStripNull(strcMapPath)
strFileName = strcMapPath & "\" & strFileName & ".DVL" 'Add path and change extension

'Delete previous version of file
    On Error Resume Next
    Kill strFileName 'alt-f5 to bypass error handler
    On Error GoTo Err_MV
'Open file as new sequential file (for output)
    Open strFileName For Output As intD

strVal = IIf(strType = "Sim", "Suitable/unsuitable", "Category")
If strType = "Sim" Or strType = "List" Then
    strData = "integer"
Else
    strData = "real"
End If

Print #intD, "file title  : Created on " & Date & " for " & spcode
Print #intD, "file type   : ascii"
Print #intD, "records     : " & RecNo
Print #intD, "fields      : 2"
Print #intD, "Field 0     : identifiers"
Print #intD, "data type   : integer"
Print #intD, "format      : 0"
Print #intD, "field 1     : attribute"
Print #intD, "data type   : " & strData
Print #intD, "format      : 0"
Print #intD, "min. value  : " & IIf(strType = "Sim", 0, dblMin)
Print #intD, "max. value  : " & IIf(strType = "Sim", 1, dblMax)
Print #intD, "value units : " & strType
Print #intD, "value Error : unknown"
Print #intD, "flag value  : none"
Print #intD, "flag def'n  : none"
Print #intD, "legend cats : 0"
Print #intD, "lineage     : From Matrix_builder project - mdMaps module - fnValuesFile procedure"
Close intD
Exit Function

Err_MV:
Call fnErrorHan
Exit Function
End Function

Public Function fnValuesFile(ByVal intRecs As Integer, ByVal strMapP As String, _
ByVal strFileName As String, ByVal dblMin As Double, ByVal dblMax As Double, ByVal strType As String, _
Optional ByVal dblMinS As Double)
'
'Function: To create a VALUES file for IDRISI (.dvl is created in separate proc).
'Format: [id] [value]. There must be the same number of values in the list _
as in the cell matrix (1755).
'Arguments: strFileName for dvl file.
' intRecs for number of records. arrCells or arrList holds values. _
It is assumed that this matrix already exists. _
Tests against column 10 or sole col. dblcMinS for Similarity test only
'Dims in this mod's general declarations.
'Returns - name of values file sans extension as mapname

intFileNo = FreeFile     'The next free file number
Dim lngP As Double, strLong As String, dblP As Double
Dim wCtr As Integer, lngId As Long, varX As Variant
On Error GoTo err_Val
strMapP = fnStripNull(strMapP)

If strFileName = "" Then
    strMsg = "Please give a name for the new values file (no extension).  "
    strMsg = strMsg & Chr$(13) & "Any old version of this file in the data directory will be deleted."
    strTitle = "Choose file name"

NameIn:
    strFileName = Trim(InputBox(strMsg, strTitle, "TMPMAP"))
    If strFileName = "" Then Exit Function
    If Len(strFileName) > 8 Then 'too long for IDRISI
        MsgBox "Please provide a name of less than 8 characters (e.g. TMPMAP).", , "Name too long"
        GoTo NameIn
    End If
End If
    
    fmAmaz.sbB.Panels(1).Text = "Preparing data"
    fmAmaz.sbB.Refresh
    strLong = strMapP & "\" & strFileName & ".val" 'Add path

'Delete previous version of vector file
    On Error Resume Next
    Kill strLong 'alt-f5 to pass to error handler if break on all
    On Error GoTo err_Val
'Open file as new sequential file (for output)
    Open strLong For Output As intFileNo

'Print to the file the records' identifiers and '0'
'(n as default), using "Format" to prevent spaces
fmAmaz.pbB.Visible = True
fmAmaz.pbB = 0 'Set progress indicator

'This is the only point at which it differs depending on value file type
fmAmaz.sbB.Panels(1).Text = "Creating values file"
If strType = "Sim" Then
'Boolean potential range
    For i = 1 To intRecs '1755
        lngId = arrCells(i, 1)
        varX = arrCells(i, 10)
        If varX = "X" Or Null Then
            lngP = 0
        ElseIf varX >= dblMinS Then 'S
            lngP = 1
        Else: lngP = 0 'Similarity
        End If
        Print #intFileNo, format(lngId); Spc(1); format(lngP) 'E.g. "677 1"
        fmAmaz.pbB = IIf(fmAmaz.pbB + ((i / intRecs) * 100) < 100, fmAmaz.pbB + ((i / intRecs) * 100), 100)
    Next i
ElseIf strType = "SimGrad" Then
'Gradient potential range
    For i = 1 To intRecs '1755
        lngId = i
        If i < 1755 Then
            varX = arrCells(i, 10)
            If varX = "X" Or IsNull(varX) Then
                lngP = 0
            Else 'If varX >= dblMinS Then 'S
                lngP = CDbl(varX) 'All sim values
            End If
        Else
            lngP = 1 'add a 1 in the bottom corner to constrain map values for display
        End If
            Print #intFileNo, format(lngId); Spc(1); format(Round(lngP, 4)) 'E.g. "677 1"
            fmAmaz.pbB = IIf(fmAmaz.pbB + ((i / intRecs) * 100) < 100, fmAmaz.pbB + ((i / intRecs) * 100), 100)
    Next i
ElseIf strType = "List" Then 'e.g. called by fnMapList
    For i = 1 To intRecs
        lngId = arrCells(i, 1) 'SAM4ID
        lngP = arrList(i) 'Value - where list has intRecs items
        Print #intFileNo, format(lngId); Spc(1); format(lngP) 'E.g. "677 -999"
        fmAmaz.pbB = IIf(fmAmaz.pbB + ((i / intRecs) * 100) < 100, fmAmaz.pbB + ((i / intRecs) * 100), 100)
    Next i
ElseIf strType = "Doub" Then
    For i = 1 To intRecs
        lngId = arrCells(i, 1) 'SAM4ID
        dblP = arrList(i) 'Value - where list has intRecs items
        Print #intFileNo, format(lngId); Spc(1); dblP 'E.g. "677 -99"
        fmAmaz.pbB = IIf(fmAmaz.pbB + ((i / intRecs) * 100) < 100, fmAmaz.pbB + ((i / intRecs) * 100), 100)
    Next i

End If
  'Need to create a dvl file as a doc file - diff ea time.
    i = fnIntDVL(strFileName, intRecs, strFileName, strMapP, strType, dblMin, dblMax) ' Create dvl file
    GoTo Close_All
    Exit Function

Close_All:
On Error Resume Next

fmAmaz.sbB.Panels(1).Text = "" 'Resets the status bar meter
fmAmaz.pbB = 0: fmAmaz.pbB.Visible = False
Close intFileNo 'Close the file
Exit Function

err_Val:
Call fnErrorHan
GoTo Close_All

Exit Function
End Function
